import 'dart:async';

import '../reactive_base.dart';

class ReactiveElement<Type> implements ReactiveBase {
  Type _value;

  final StreamController<Type> _controller = StreamController<Type>.broadcast();

  @override
  Stream get onChange => _controller.stream;

  Type get value => _value;

  ReactiveElement({Type initialValue}) {
    _value = initialValue;
    _controller.sink.add(_value);
  }

  void change(Type value) {
    _value = value;
    _controller.sink.add(value);
  }

  void dispose() {
    _controller.close();
  }
}
